# bera(倍良)

## 概要

コマンドラインでバックアップを取るシェルスクリプトです。

ハノイの塔方式で，バックアップを取ります。

## 著作権

Copyright © 2018-2020 Seiichiro HATA

## 連絡先

<infotech@hata-o.jp>

ご要望やバグ情報のご連絡には，速やかに対応するように努めておりますが，
多忙のため，全てのメールにお返事はいたしかねますので，ご了承ください。

## ウェブページ

<http://hata-o.jp/kian/?tools>

## 動作環境

UNIX系の環境であれば，たぶん動くと思います。

## インストール方法

このディレクトリ内の「bera」を，
パスの通っているディレクトリ（「/usr/local/bin/」等）にコピーし，
適切な実行権限を確認してください。

## アンインストール方法

コピーした「bera」を削除してください。

必要があれば，バックアップしたデータを削除してください。

## 使用方法

ファイル"file"をディレクトリ"directory"にバックアップします。
> bera <file> <directory>

バックアップするファイルの数を"number"に指定して（デフォルトは8），
ファイル"file"をディレクトリ"directory"にバックアップします。
> bera -n <number> <file> <directory>

## ライセンス

GNU General Public Licenseバージョン3 (GPLv3)又はその後継バージョン

GPLv3のライセンス条項は，LICENSE-GPLv3.txtをご覧ください。

## 免責条項

ライセンスに定められているとおり，本プログラムにより損害が発生したとしても，
著作権者は何らの損害賠償責任も負いませんので，ご注意ください。

## 問題点

要望があれば，GUIにも対応したいと思っています。

## 開発動機

コンピューターを使っていると，うっかりファイルを消去してしまうことがあります。
また，何らかの原因でファイルが壊れてしまい，アプリケーションソフトから
開けなくなってしまうことがあります。
さらに，HDD（ハードディスクドライブ）やSSD（ソリッドステートドライブ）などの
補助記憶装置が故障してしまい，データが取り出せなくなることもあります。

そこで，重要なデータを扱う際は，そのようなトラブルに備えて，
日頃からバックアップを取っておく必要があります。

バックアップは，たくさん取っておくことに越したことはありません。
可能であれば，毎日，バックアップを取って，そのデータをすべて残しておくべきです。

しかし，バックアップを保存するメディア（HDDやSSDなど）の容量にも限りがあります。

そこで，限られたメディア容量で，要領よくバックアップを取ることを考えざるを
得ません。

例えば，AからJまでの10個のフォルダを作って，次のようにバックアップを取ります。

 1日目  Aフォルダにデータをコピー
 2日目  Bフォルダにデータをコピー
 3日目  Cフォルダにデータをコピー
 4日目  Dフォルダにデータをコピー
 5日目  Eフォルダにデータをコピー
 6日目  Fフォルダにデータをコピー
 7日目  Gフォルダにデータをコピー
 8日目  Hフォルダにデータをコピー
 9日目  Iフォルダにデータをコピー
10日目  Jフォルダにデータをコピー
11日目  Aフォルダにデータをコピー
12日目  Bフォルダにデータをコピー
13日目  Cフォルダにデータをコピー
  ⋮              ⋮

もちろん，11日目以降は，フォルダ内の古いデータを消してから，データをコピーする
ようにします。

この場合，メディアの容量は，バックアップを取る必要のあるデータのサイズの
約10倍も必要になります。

それでも，これだと10日前までのデータしか残りません。
ファイルをうっかり削除して，気が付かないまま2週間を経過してしまった場合には，
バックアップが残っていません。

そこで，毎日データを取るのではなく，月に1回にしてみます。

 1か月目  Aフォルダにデータをコピー
 2か月目  Bフォルダにデータをコピー
 3か月目  Cフォルダにデータをコピー
 4か月目  Dフォルダにデータをコピー
 5か月目  Eフォルダにデータをコピー
 6か月目  Fフォルダにデータをコピー
 7か月目  Gフォルダにデータをコピー
 8か月目  Hフォルダにデータをコピー
 9か月目  Iフォルダにデータをコピー
10か月目  Jフォルダにデータをコピー
11か月目  Aフォルダにデータをコピー
12か月目  Bフォルダにデータをコピー
13か月目  Cフォルダにデータをコピー
  ⋮              ⋮

この場合，10か月前のデータは残りますが，3日前に作成したファイルを
うっかり削除した場合には，バックアップが残っていない可能性が大きいです。

そこで，両者のバランスを考えて，限られたデータ容量の中で，昔のデータの
バックアップも少し残しながら，最近のデータのバックアップを小まめに残すのが
理想的です。
バックアップは時間が経つにつれて価値が下がっていくので，この考え方は非常に
合理的です。

具体的には，Aフォルダは非常に小まめに，Bフォルダはまあまあ小まめに，
Cフォルダはちょっぴり小まめに…，Iフォルダはまあまあ希に，Jフォルダは非常に
希にバックアップを取ります。

そのために，1/2の有限等比級数を考えます。

1/2 + 1/4 + 1/8 + 1/16 + 1/32 + 1/64 + 1/128 + 1/256 + 1/512 + 1/1024×2
    = 1/2 + 1/4 + 1/8 + 1/16 + 1/32 + 1/64 + 1/128 + 1/256 + 1/512 + 1/512
    = 1/2 + 1/4 + 1/8 + 1/16 + 1/32 + 1/64 + 1/128 + 1/256 + 1/256
    = 1/2 + 1/4 + 1/8 + 1/16 + 1/32 + 1/64 + 1/128 + 1/128
    = 1/2 + 1/4 + 1/8 + 1/16 + 1/32 + 1/64 + 1/64
    = 1/2 + 1/4 + 1/8 + 1/16 + 1/32 + 1/32
    = 1/2 + 1/4 + 1/8 + 1/16 + 1/16
    = 1/2 + 1/4 + 1/8 + 1/8
    = 1/2 + 1/4 + 1/4
    = 1/2 + 1/2
    = 1

そして，"1/2"をAフォルダに，"1/4"をBフォルダに，"1/8"をCフォルダに…，
"1/512"をIフォルダに，"1/1024×2"をJフォルダに対応させて考えてみます。
すなわち，Aフォルダは2日に1回，Bフォルダは4日に1回，Cフォルダは8日に1回…，
Iフォルダは512日に1回，Jフォルダは1024×2=512日に1回，
バックアップを取ることを考えてみます。

 1日目  Aフォルダにデータをコピー
 2日目  Bフォルダにデータをコピー
 3日目  Aフォルダにデータをコピー
 4日目  Cフォルダにデータをコピー
 5日目  Aフォルダにデータをコピー
 6日目  Bフォルダにデータをコピー
 7日目  Aフォルダにデータをコピー
 8日目  Dフォルダにデータをコピー
 9日目  Aフォルダにデータをコピー
10日目  Bフォルダにデータをコピー
11日目  Aフォルダにデータをコピー
12日目  Cフォルダにデータをコピー
13日目  Aフォルダにデータをコピー
  ⋮              ⋮

こうすると，最も新しいデータは1日前のデータ，次に新しいデータは2日前のデータに
なります。
その後は，3ないし4日前のデータ，5ないし8日前のデータ，9ないし16日前のデータと
なり，最も古いデータは255ないし512日前のデータになります。

すなわち，新しいデータはたくさん，古いデータはちょっとだけ，バックアップとして
残すことができるのです。

このようなバックアップ方式をハノイの塔方式といいますが，本プログラムは簡単に
ハノイの塔方式でバックアップを取るものです。

## ヒストリー

### 2020.08.19 v02 リリース

ファイルの更新を確認する速度重視のアルゴリズムを変更しました。
ファイルの更新を確認しないオプションを追加しました。
バグを修正しました。

### 2019.08.06 v01 リリース

最初の公開になります。
